﻿enyo.kind({
    name: "enyo.CanonMaps",
    kind: enyo.VFlexBox,
    components: [
        { kind: "AppMenu", components: [
			{ name: "picker", kind: "Picker",
				value: "yandex",
				items: [
					{caption: "Yandex", value: "yandex"},
					{caption: "Google", value: "google"},
					{caption: "OSM", value: "osm"}
				],
				onChange: "pickerPick"
			},
			
            { caption: "About", onclick: "onMenuAbout" },
            { caption: "Exit", onclick: "onMenuExit" }
        ]
        },
		{ name: "openApp", kind: "PalmService", service: "palm://com.palm.applicationManager/", method: "open" },
		{ name: "slidingPane", kind: "SlidingPane", flex: 1, components: [
			//{ name: "left", width: "20px", components: [
				//{ kind: "VFlexBox", flex: 1, components: [
					//{ kind: "Item", layoutKind: "HFlexLayout", align: "left", components: [
							//{ content: $L("Traffic"), flex: 1, style: "padding-left: 10px;padding-right: 10px;" },
                            //{ kind: "ToggleButton", onLabel: "on", offLabel: "off", onChange: "buttonToggle" }
					//]
					//},
                    //{ name: "divider", kind: "Divider", caption: "Layers", showing: true },
					//{ name: "list", kind: "VirtualList", flex: 1, onSetupRow: "listSetupRow", components: [
						//{ kind: "Item", layoutKind: "HFlexLayout", align: "left", onclick: "itemClick", components: [
							    //{ name: "name", flex: 1, style: "padding-left: 10px;padding-right: 10px;" },
                                //{ name: "btnOn", kind: "CheckBox", caption: "on" }
						//]
						//}
					//]
					//},
				//]
				//}
			//]
			//},
			{ name: "right", flex: 1, dragAnywhere: false, onResize: "slidingResize", components: [
				{ kind: "VFlexBox", flex: 1, components: [
					{ name: "map", kind: "enyo.YandexMap", showing: true,
					    mapType: "yandex#map", zoom: 10,
					    onConnectionAvail: "connectionAvail", onConnectionFailure: "connectionFailure"
					},
                    { tag: "div", name: "ymapsdiv", style: "width:100%; height:100%; background-color:#f8f8f8;",
                        components: [
                            { name: "noconn", kind: "Image", src: "images/no-wifi.png", showing: false,
                                width: "110px", height: "98px", className: "centeredImage"
                            }
                        ]
                    }
				]
				},
				{ kind: "Toolbar", className: "enyo-toolbar-light", components: [
                    //{ kind: "Image", src: "images/where_am_i.png" },
					{ kind: "HFlexBox", align: "center", style: "padding: 5px", components: [
						{content: "Traffic ", flex: 1},
						{ kind: "ToggleButton", onLabel: "on", offLabel: "off", onChange: "buttonToggle" }
					]
					}
				]
				}
			]
			}
		]
		},
        { name: "aboutDialog", kind: "ModalDialog", caption: $L("О программе"), width: "300px", components: [
		    { kind: "HFlexBox", components: [
	            { components: [
		            { kind: "Image", src: 'images/about_icon.png', style: "margin-right: 10px" }
			    ]
	            },
			    { components: [
			        { content: $L("Яндекс.Карты для WebOS"), className: 'enyo-text-subheader enyo-text-ellipsis' },
	                { content: $L("Версия 0.0.4"), className: 'enyo-text-ellipsis enyo-subtext' }
			    ]
			    }
	        ]
		    },
            { layoutKind: "HFlexLayout", pack: "center", components: [
                { kind: "Button", caption: "OK", width: "120px", onclick: "okClick" },
            ]
            }
        ]
        }
	],
    onMenuAbout: function () {
        this.openAboutDialog();
    },
    onMenuExit: function () {
        window.close();
    },
    openAboutDialog: function () {
        this.$.aboutDialog.openAtCenter();
    },
    connectionFailure: function () {
        if (this.connIsOn == null || this.connIsOn) {
            enyo.windows.addBannerMessage("No internet connection is currently available", "{}", "{}", "notification");
            console.log("connectionFailure");
            this.$.noconn.show();
            this.connIsOn = false;
        }
    },
    connectionAvail: function () {
        console.log("connectionAvail");
        this.connIsOn = true;
        this.$.noconn.hide();
    },
    rendered: function () {
        this.inherited(arguments);
        //this.$.slidingPane.selectView(this.$.right);
    },
    slidingResize: function (inSender, inRow) {
        this.$.map.resizeMap();
    },
    pickerPick: function (inSender) {
        var c = this.$.picker.getValue();
        if (c == "yandex" || c == "google" || c == "osm") {
            this.$.map.changeLayer(c);
        }
    },
    buttonToggle: function (inSender, inState) {
        if (this.$.map.shownTraffic)
            this.$.map.hideTraffic();
        else
            this.$.map.showTraffic();
    },
    okClick: function () {
        this.$.aboutDialog.close();
    },
    gesturestartHandler: function (inSender, e) {
        this.previousScale = e.scale;
    },
    gesturechangeHandler: function (inSender, e) {
        var d = this.previousScale - e.scale;
        if (Math.abs(d) > 0.25) {
            var z = this.$.map.getZoom() + (d > 0 ? -1 : +1);
            this.$.map.setZoom(z);
            this.previousScale = e.scale;
        }
    },
    gestureendHandler: function (inSender, e) {
    }
})
